module ContainersCp
  module Context
    extend ::ActiveSupport::Concern

    included do
      set_callback :invoke, :around, :initialize_context

      attr_reader :account, :account_id, :provider

      def initialize_context
        @customer_id = @options[:customer_id]
        customer = ::Multidb.use(:master) { ::Customer.find(@customer_id) }
        account_id = @options[:aws_account_id]
        @provider = @options[:provider]

        # Currently the kubernetes agent does not supply account id information
        # on any of the assets, so we will not process account id.
        account = OpenStruct.new
        account.id = nil
        @account = account
        @account_id = account.id

        yield
      end
    end
  end
end
